import React, { CSSProperties } from 'react';
import 'antd/lib/form/style';
import 'antd/lib/table/style';
import 'antd/lib/input/style';
import 'antd/lib/pagination/style';
import 'antd/lib/tooltip/style';
import 'antd/lib/select/style';
import 'antd/lib/input-number/style';
import 'antd/lib/date-picker/style';
import 'antd/lib/checkbox/style';
import 'antd/lib/divider/style';
import 'antd/lib/popover/style';
import 'antd/lib/list/style';
import { ColumnType } from 'antd/lib/table';
import { FormInstance } from 'antd/lib/form';
interface ETableColEditorProps {
    type?: 'select' | 'datetime' | 'string' | 'checkbox' | 'number' | 'date' | 'time';
    required?: boolean;
    validator?: (...arg: any[]) => void;
    options?: any[];
    format?: string;
    max?: number;
    min?: number;
    regex?: RegExp;
    component?: () => React.ReactElement;
}
interface ETableColProps<T> extends ColumnType<T> {
    editable?: (...arg: any[]) => boolean | true | false;
    editor?: ETableColEditorProps;
    children?: ETableColProps<any>[];
}
export interface ETableProps {
    name?: string;
    bordered?: boolean;
    lang?: 'zh' | 'en' | 'pt_br';
    rowKey?: string;
    title?: string;
    style?: CSSProperties;
    newRowKeyPrefix?: string;
    cols?: ETableColProps<any>[];
    allCols?: ETableColProps<any>[];
    data?: any[];
    changedData?: any[];
    loading?: boolean;
    currentPage?: number;
    pageSize?: number;
    total?: number;
    scroll?: any;
    multiSelect?: boolean;
    showHeader?: boolean;
    showFooter?: boolean;
    showToolbar?: boolean;
    showAddBtn?: boolean;
    showOpBtn?: boolean;
    showSelectRecord?: boolean;
    showSelector?: boolean;
    showTopPager?: boolean;
    showBottomPager?: boolean;
    buttons?: React.ReactElement;
    canEdit?: (...args: any[]) => boolean;
    canRemove?: (...args: any[]) => boolean;
    beforeEdit?: (...args: any[]) => any;
    afterEdit?: (...args: any[]) => any;
    onAdd?: (...args: any[]) => any;
    onFetch?: (...args: any[]) => void;
    onChangedDataUpdate?: (...args: any[]) => void;
    onDownload?: (...args: any[]) => any;
    onSelectRow?: (...args: any[]) => void;
    expandedRowRender?: (record: any) => React.ReactNode;
    expandedFirstRow?: boolean;
    editOnSelected?: boolean;
    onExpandedRow?: (...args: any[]) => void;
    parentForm?: FormInstance;
}
interface StateProps {
    currentPage?: number;
}
declare const _default: {
    new (props: any): {
        resetTable: () => void;
        render(): JSX.Element;
        context: any;
        setState<K extends "currentPage">(state: StateProps | ((prevState: Readonly<StateProps>, props: Readonly<any>) => StateProps | Pick<StateProps, K> | null) | Pick<StateProps, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<any> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<StateProps>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<any>, nextState: Readonly<StateProps>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<any>, prevState: Readonly<StateProps>): any;
        componentDidUpdate?(prevProps: Readonly<any>, prevState: Readonly<StateProps>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<StateProps>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<StateProps>, nextContext: any): void;
    };
    contextType?: React.Context<any> | undefined;
};
export default _default;
