import React, { Component, useState, useMemo, useEffect, useContext } from 'react';
import { DatePicker, Form, List, Checkbox, Table, Empty, Divider, Tooltip, Popover, Pagination, Row, Col, Button, InputNumber, Select, TimePicker, Input } from 'antd';
import 'antd/lib/form/style';
import 'antd/lib/table/style';
import 'antd/lib/input/style';
import 'antd/lib/pagination/style';
import 'antd/lib/tooltip/style';
import 'antd/lib/select/style';
import 'antd/lib/input-number/style';
import 'antd/lib/date-picker/style';
import 'antd/lib/checkbox/style';
import 'antd/lib/divider/style';
import 'antd/lib/popover/style';
import 'antd/lib/list/style';
import moment from 'moment';
import { Resizable } from 'react-resizable';
import _ from 'lodash';
import { DownOutlined, RightOutlined, FilterFilled, FilterOutlined, RestFilled, SearchOutlined, UnorderedListOutlined, DownloadOutlined, ColumnHeightOutlined, VerticalAlignMiddleOutlined, CheckOutlined, CloseOutlined, EditOutlined, DeleteOutlined, DeleteFilled, PlusOutlined } from '@ant-design/icons';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = "/* stylelint-disable at-rule-empty-line-before,at-rule-name-space-after,at-rule-no-unknown */\n/* stylelint-disable no-duplicate-selectors */\n/* stylelint-disable */\n/* stylelint-disable declaration-bang-space-before,no-duplicate-selectors,string-no-newline */\n.index_antETable__3oVok .index_antETableHeader__1I6qa {\n  display: -webkit-box;\n  display: flex;\n  background-color: #f5f5f5;\n  padding: 4px 8px;\n  border-bottom: 1px solid #f0f0f0;\n}\n.index_antETable__3oVok .index_antETableHeader__1I6qa .index_antETableTitleContainer__2298P {\n  width: 80%;\n  display: -webkit-box;\n  display: flex;\n}\n.index_antETable__3oVok .index_antETableHeader__1I6qa .index_antETableTitle__1JmyL {\n  color: rgba(0, 0, 0, 0.85);\n  font-weight: 400;\n  font-size: 14px;\n  white-space: nowrap;\n}\n.index_antETable__3oVok .index_antETableHeader__1I6qa .index_antETableToolbar__j22qb {\n  margin-left: 8px;\n  display: -webkit-box;\n  display: flex;\n  justify-content: space-around;\n}\n.index_antETable__3oVok .index_antETableHeader__1I6qa .index_antETableToolbar__j22qb > div {\n  line-height: 24px;\n}\n.index_antETable__3oVok .index_antETableHeader__1I6qa .index_antETableToolbar__j22qb > span > svg {\n  margin-top: 6px;\n  margin-right: 16px;\n  cursor: pointer;\n  font-size: 12px;\n}\n.index_antETable__3oVok .index_antETableHeader__1I6qa .index_antETableToolbar__j22qb .ant-pagination-item-link {\n  background-color: transparent;\n}\n.index_antETable__3oVok .index_antETableHeader__1I6qa .index_antETableToolbarRight__17sCn {\n  width: 20%;\n  text-align: right;\n}\n.index_antETable__3oVok .index_antETableHeader__1I6qa .index_antETableToolbarRight__17sCn > span > svg {\n  margin-top: 6px;\n  margin-right: 16px;\n  cursor: pointer;\n  font-size: 12px;\n}\n.index_antETable__3oVok .index_antETableFilter__2GuJn {\n  min-height: 30px;\n}\n.index_antETable__3oVok .index_antETableFilter__2GuJn td {\n  border-bottom: 1px solid #d9d9d9;\n}\n.index_antETable__3oVok .index_antETableFilter__2GuJn td:last-of-type {\n  border-right: 1px solid #d9d9d9;\n}\n.index_antETable__3oVok .index_antETableFilter__2GuJn .ant-input {\n  background-color: transparent;\n}\n.index_antETable__3oVok .index_antETableFilter__2GuJn .ant-input-affix-wrapper {\n  background-color: transparent;\n}\n.index_antETable__3oVok .index_antETableFilter__2GuJn .ant-select-selector {\n  background-color: transparent;\n}\n.index_antETable__3oVok .index_antETableBottomBar__2l4_M {\n  display: -webkit-box;\n  display: flex;\n  -webkit-box-pack: justify;\n          justify-content: space-between;\n}\n.index_antETable__3oVok .index_antETableContent__3wI2E {\n  border: 1px solid #d9d9d9;\n  border-radius: 4px;\n}\n.index_antETable__3oVok .ant-table table {\n  table-layout: fixed;\n}\n.index_antETable__3oVok .ant-table tbody > tr .ant-table {\n  margin: 0 !important;\n}\n.index_antETable__3oVok .ant-table-tbody > tr .ant-table-wrapper:only-child .ant-table {\n  margin: 0 !important;\n}\n.index_antETable__3oVok .ant-table-tbody > tr .ant-table-wrapper:only-child .ant-table td {\n  background-color: #fff !important;\n}\n.index_antETable__3oVok .ant-table-pagination {\n  margin-top: 24px;\n}\n.index_antETable__3oVok .ant-table-thead .react-resizable {\n  position: relative;\n}\n.index_antETable__3oVok .ant-table-thead .react-resizable-handle {\n  position: absolute;\n  width: 10px;\n  height: 100%;\n  bottom: 0;\n  right: -5px;\n  cursor: col-resize;\n  z-index: 1;\n  background-image: none;\n}\n.index_antETable__3oVok .ant-table-tbody tr td {\n  word-break: keep-all;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n}\n.index_antETable__3oVok .ant-table-footer {\n  padding: 8px;\n}\n.index_antETable__3oVok .ant-table-footer .ant-btn-sm {\n  line-height: unset;\n}\n.index_antETable__3oVok .ant-pagination-total-text {\n  margin-right: 0;\n}\n.index_antETable__3oVok .ant-table-placeholder {\n  border-radius: 0;\n}\n.index_antETable__3oVok .ant-input {\n  -webkit-transition: none;\n  transition: none;\n}\n.index_antETable__3oVok .ant-table-cell {\n  padding: 8px;\n}\n.index_antETable__3oVok .ant-table-expanded-row .ant-input {\n  background-color: transparent;\n}\n.index_antETable__3oVok .ant-table-expanded-row .ant-input-affix-wrapper {\n  background-color: transparent;\n}\n.index_antETable__3oVok .ant-table-expanded-row .ant-select-selector {\n  background-color: transparent;\n}\n";
var styles = {"antETable":"index_antETable__3oVok","antETableHeader":"index_antETableHeader__1I6qa","antETableTitleContainer":"index_antETableTitleContainer__2298P","antETableTitle":"index_antETableTitle__1JmyL","antETableToolbar":"index_antETableToolbar__j22qb","antETableToolbarRight":"index_antETableToolbarRight__17sCn","antETableFilter":"index_antETableFilter__2GuJn","antETableBottomBar":"index_antETableBottomBar__2l4_M","antETableContent":"index_antETableContent__3wI2E"};
styleInject(css);

var en = {
  'filter.expand': 'Expand Filter',
  'filter.collapse': 'Collapse Filter',
  'filter.clear': 'Clear Filter',
  'total.prefix': 'Total',
  'total.suffix': 'Rows',
  'add': 'Add',
  'edit': 'Edit',
  'delete': 'Delete',
  'undelete': 'UnDelete',
  'ok': 'Ok',
  'cancel': 'Cancel',
  'op': 'Operation',
  'search': 'Search',
  'columns': 'Columns',
  'download': 'Download',
  'select': 'Select Record',
  'collapse': 'Collapse Table',
  'expand': 'Expand Table',
  'empty': 'No Data'
};

var zh = {
  'filter.expand': '展开过滤器',
  'filter.collapse': '收起过滤器',
  'filter.clear': '清除过滤器',
  'total.prefix': '共',
  'total.suffix': '条',
  'add': '添加',
  'edit': '编辑',
  'delete': '删除',
  'undelete': '取消删除',
  'ok': '确定',
  'cancel': '取消',
  'op': '操作',
  'search': '查询',
  'columns': '显示列',
  'download': '下载',
  'select': '选择记录',
  'collapse': '收起',
  'expand': '展开',
  'empty': '无数据'
};

var pt_br = {
  'filter.expand': 'Expandir filtro',
  'filter.collapse': 'Esconder filtro',
  'filter.clear': 'Remover filtro',
  'total.prefix': 'Total',
  'total.suffix': 'Linhas',
  'add': 'Adicionar',
  'edit': 'Editar',
  'delete': 'Excluir',
  'undelete': 'Desfazer excluir',
  'ok': 'Ok',
  'cancel': 'Cancelar',
  'op': 'Ação',
  'search': 'Procurar',
  'columns': 'Colunas',
  'download': 'Baixar',
  'select': 'Selecionar Registro',
  'collapse': 'Esconder Mesa',
  'expand': 'Expandir Mesa',
  'empty': 'Sem Dados'
};

var locale = {
  en: en,
  pt_br: pt_br,
  zh: zh
};

var RangePicker = DatePicker.RangePicker;
var EditableContext = React.createContext({});
var dateTimeFormat = 'YYYY-MM-DD HH:mm:ss';
var dateFormat = 'YYYY-MM-DD';
var timeFormat = 'HH:mm';

function updateChangedData(changedData, item) {
  var rowKey = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'id';
  var result;
  var idx = changedData.findIndex(function (d) {
    return item[rowKey] === d[rowKey];
  });
  var older = changedData.find(function (d) {
    return item[rowKey] === d[rowKey];
  });

  if (item.isDelete) {
    if (older && (older.isNew || !older.isUpdate)) {
      result = [].concat(_toConsumableArray(changedData.slice(0, idx)), _toConsumableArray(changedData.slice(idx + 1)));
    } else if (older && older.isDelete && older.isUpdate) {
      result = changedData.map(function (d) {
        if (item[rowKey] === d[rowKey]) {
          return _objectSpread2({}, d, {
            isDelete: false
          });
        }

        return d;
      });
    } else if (older && !older.isDelete) {
      result = changedData.map(function (d) {
        if (item[rowKey] === d[rowKey]) {
          return _objectSpread2({}, d, {
            isDelete: true
          });
        }

        return d;
      });
    } else {
      result = [].concat(_toConsumableArray(changedData), [_objectSpread2({}, item, {
        isDelete: true
      })]);
    }
  } else if (idx > -1) {
    result = changedData.map(function (d) {
      if (item[rowKey] === d[rowKey]) {
        return _.merge({}, d, item);
      }

      return d;
    });
  } else {
    result = [].concat(_toConsumableArray(changedData), [item]);
  }

  return result;
}

function exportCSV(payload) {
  var name = payload.name,
      header = payload.header,
      data = payload.data;

  if (payload && data.length > 0) {
    var str = header.map(function (h) {
      return h.title;
    }).join(',') + '\n';
    str += data.map(function (d) {
      return header.map(function (h) {
        return _.get(d, [h.dataIndex]);
      }).join(',');
    }).join('\n');
    var blob = new Blob(["\uFEFF" + str], {
      type: 'text/csv;charset=utf-8;'
    });
    var filename = "".concat(name, ".csv");
    var link = document.createElement('a');

    if (link.download !== undefined) {
      var url = URL.createObjectURL(blob);
      link.setAttribute('href', url);
      link.setAttribute('download', filename);
      link.style.visibility = 'hidden';
      document.body.appendChild(link);
      link.click();
      document.body.removeChild(link);
    }
  }
}

function flatCols(columns) {
  return columns.flatMap(function (col) {
    return 'children' in col ? flatCols(col.children) : col;
  });
}

function initChildCols(col, idx, editingKey, rowKey) {
  if (col.children) {
    return _objectSpread2({}, col, {
      children: col.children.map(function (child, i) {
        return initChildCols(child, idx + '' + i, editingKey, rowKey);
      })
    });
  } else if (!col.editable) {
    return col;
  } else {
    var isEditing = function isEditing(record) {
      if (!col.editable || _.isFunction(col.editable) && !col.editable(record)) return false;else return record[rowKey] === editingKey;
    };

    return _objectSpread2({}, col, {
      onCell: function onCell(record) {
        return {
          record: record,
          editor: col.editor,
          editing: isEditing(record),
          dataIndex: col.dataIndex,
          title: col.title
        };
      },
      onHeaderCell: function onHeaderCell(col) {
        return {
          width: col.width,
          index: idx
        };
      }
    });
  }
}

function isFixedHeader(children) {
  return !!children.find(function (c) {
    return !!c.props.fixed;
  });
}

function setFormValue(form, record, columns) {
  var tmp = {};

  _.keys(record).map(function (k) {
    var col = columns.find(function (c) {
      return c.dataIndex === k;
    });

    if (col && col.editor && col.editor.type === 'datetime') {
      tmp[k] = moment(record[k], dateTimeFormat);
    } else if (col && col.editor && col.editor.type === 'date') {
      tmp[k] = moment(record[k], dateFormat);
    } else if (col && col.editor && col.editor.type === 'time') {
      tmp[k] = moment(record[k], timeFormat);
    } else {
      tmp[k] = record[k];
    }
  });

  form.setFieldsValue(tmp);
}

var EditableHWrapper = function EditableHWrapper(_ref) {
  var className = _ref.className,
      children = _ref.children;

  var _useContext = useContext(EditableContext),
      filter = _useContext.filter,
      filterVisible = _useContext.filterVisible,
      setFilter = _useContext.setFilter,
      columns = _useContext.columns,
      handleTableChange = _useContext.handleTableChange,
      showSelector = _useContext.showSelector,
      expandedRowRender = _useContext.expandedRowRender;

  var flatColumns = useMemo(function () {
    return flatCols(columns);
  }, [columns]);
  return React.createElement("thead", {
    className: className
  }, children, !isFixedHeader(children) && filterVisible && React.createElement("tr", {
    className: styles.antETableFilter
  }, expandedRowRender && React.createElement("th", {
    key: "expandedRow"
  }), showSelector && React.createElement("th", {
    key: "filterSelector"
  }), flatColumns.map(function (col, idx) {
    var _col$editor = col.editor,
        editor = _col$editor === void 0 ? {} : _col$editor,
        _col$align = col.align,
        align = _col$align === void 0 ? 'left' : _col$align;
    if (col.dataIndex) return React.createElement("th", {
      key: "filter".concat(idx),
      style: {
        padding: 5,
        textAlign: align
      }
    }, getFilterInput(editor, _.get(filter, col.dataIndex), function (value) {
      if (_.isArray(col.dataIndex)) {
        setFilter(_.merge({}, filter, _.set({}, col.dataIndex, value)));
      } else {
        setFilter(_objectSpread2({}, filter, _defineProperty({}, col.dataIndex, value)));
      }
    }, handleTableChange));else return React.createElement("th", {
      key: "null".concat(idx)
    });
  }).filter(function (a) {
    return a !== undefined;
  })));
};

var getFilterInput = function getFilterInput(editor, value, _onChange, onSearch) {
  var _editor$type = editor.type,
      type = _editor$type === void 0 ? 'string' : _editor$type,
      _editor$options = editor.options,
      options = _editor$options === void 0 ? [] : _editor$options,
      format = editor.format;

  switch (type) {
    case 'number':
      return React.createElement(InputNumber, {
        value: value,
        onChange: function onChange(value) {
          return _onChange(value);
        },
        onKeyPress: function onKeyPress(e) {
          return e.nativeEvent.key === 'Enter' ? onSearch({
            currentPage: 1
          }) : null;
        }
      });

    case 'select':
      return React.createElement(Select, {
        style: {
          width: '100%'
        },
        value: value,
        onChange: function onChange(value) {
          return _onChange(value);
        }
      }, options.map(function (o) {
        return React.createElement(Select.Option, {
          key: o.key,
          value: o.key
        }, o.value);
      }));

    case 'datetime':
      return React.createElement(RangePicker, {
        style: {
          width: '100%'
        },
        showTime: true,
        format: format ? format : dateTimeFormat,
        value: value,
        onChange: function onChange(dates) {
          return _onChange(dates);
        }
      });

    case 'date':
      return React.createElement(RangePicker, {
        style: {
          width: '100%'
        },
        format: format ? format : dateFormat,
        value: value,
        onChange: function onChange(dates) {
          return _onChange(dates);
        }
      });

    case 'time':
      return React.createElement(TimePicker, {
        style: {
          width: '100%'
        },
        format: format ? format : timeFormat,
        value: value,
        onChange: function onChange(dates) {
          return _onChange(dates);
        }
      });

    case 'checkbox':
      return React.createElement(Checkbox, {
        checked: value,
        onChange: function onChange(e) {
          return _onChange(e.target.checked);
        }
      });

    case 'string':
      return React.createElement(Input, {
        value: value,
        onChange: function onChange(e) {
          return _onChange(e.target.value.trim());
        },
        onKeyPress: function onKeyPress(e) {
          return e.nativeEvent.key === 'Enter' ? onSearch({
            currentPage: 1
          }) : null;
        }
      });

    default:
      return React.createElement(Input, {
        value: value,
        onChange: function onChange(e) {
          return _onChange(e.target.value.trim());
        },
        onKeyPress: function onKeyPress(e) {
          return e.nativeEvent.key === 'Enter' ? onSearch({
            currentPage: 1
          }) : null;
        }
      });
  }
};

var ResizeableCell = function ResizeableCell(_ref2) {
  var index = _ref2.index,
      width = _ref2.width,
      restProps = _objectWithoutProperties(_ref2, ["index", "width"]);

  var _useContext2 = useContext(EditableContext),
      columns = _useContext2.columns,
      setColumns = _useContext2.setColumns;

  if (!width) {
    return React.createElement("th", restProps);
  }

  return React.createElement(Resizable, {
    width: width,
    height: 0,
    onResize: function onResize(e, _ref3) {
      var size = _ref3.size;

      var nextColumns = _toConsumableArray(columns);

      nextColumns[index] = _objectSpread2({}, nextColumns[index], {
        width: size.width
      });
      setColumns(nextColumns);
      e.stopPropagation();
    },
    draggableOpts: {
      enableUserSelectHack: false
    }
  }, React.createElement("th", restProps));
};

var EditableRow = function EditableRow(props) {
  var _useContext3 = useContext(EditableContext),
      changedData = _useContext3.changedData,
      selectedRowKeys = _useContext3.selectedRowKeys,
      rowKey = _useContext3.rowKey;

  var key = props['data-row-key'];
  var isDelete = changedData.find(function (d) {
    return key === d[rowKey] && d.isDelete;
  });
  var style = props.style;
  var selected = selectedRowKeys.find(function (i) {
    return key === i;
  });

  if (selected) {
    style = _objectSpread2({}, style, {
      fontWeight: 800
    });
  }

  var deleteStyle = {
    borderTop: '1px solid #000',
    position: 'absolute',
    height: 1,
    width: 'calc(100% - 4px)',
    marginTop: -20
  };
  return React.createElement(React.Fragment, null, React.createElement("tr", _extends({}, props, {
    style: style
  })), isDelete && React.createElement("tr", {
    style: deleteStyle
  }));
};

var EditableCell = function EditableCell(_ref4) {
  var _ref4$editor = _ref4.editor,
      editor = _ref4$editor === void 0 ? {
    type: 'string'
  } : _ref4$editor,
      editing = _ref4.editing,
      dataIndex = _ref4.dataIndex,
      title = _ref4.title,
      record = _ref4.record,
      index = _ref4.index,
      children = _ref4.children,
      restProps = _objectWithoutProperties(_ref4, ["editor", "editing", "dataIndex", "title", "record", "index", "children"]);

  var rules = [];
  var _editor$type2 = editor.type,
      type = _editor$type2 === void 0 ? 'string' : _editor$type2,
      required = editor.required,
      validator = editor.validator,
      min = editor.min,
      max = editor.max,
      regex = editor.regex,
      component = editor.component;

  if (required) {
    rules.push({
      required: editor.required,
      message: "".concat(title, "\u5FC5\u586B.")
    });
  }

  if (validator) {
    rules.push({
      validator: function validator(rule, value, callback) {
        return editor.validator(rule, value, callback, record);
      }
    });
  }

  if (type === 'string' && max) {
    rules.push({
      type: 'string',
      max: max,
      message: '字段超出长度'
    });
  } else if (type === 'number' && max && min) {
    rules.push({
      type: 'number',
      max: max,
      min: min,
      message: '数值超出范围'
    });
  }

  if (type === 'string' && regex) {
    rules.push({
      type: 'string',
      pattern: regex,
      message: '内容不符合要求'
    });
  }

  return React.createElement("td", restProps, editing ? component ? component() : React.createElement(Form.Item, {
    style: {
      margin: '-12px -4px'
    },
    rules: rules,
    name: dataIndex,
    getValueProps: function getValueProps(value) {
      if ((editor.type === 'datetime' || editor.type === 'date' || editor.type === 'time') && _.isObject(value)) {
        if (value.isValid()) {
          return {
            value: value
          };
        } else {
          return moment();
        }
      } else if (editor.type === 'datetime' || editor.type === 'date' || editor.type === 'time') {
        if (!value) return moment();
        return {
          value: moment(value)
        };
      }

      return {
        value: value
      };
    },
    getValueFromEvent: function getValueFromEvent(e) {
      if (editor.type === 'datetime') return moment(e).format("YYYY-MM-DD HH:mm:ss");else if (editor.type === 'date') return moment(e).format("YYYY-MM-DD");else if (editor.type === 'time') return moment(e).format("HH:mm");else if (editor.type === 'number' || editor.type === 'select') return e;else return e.target.value;
    },
    valuePropName: editor.type === 'checkbox' ? 'checked' : 'value'
  }, getInput(editor)) : children);
};

var getInput = function getInput(editor) {
  var _editor$type3 = editor.type,
      type = _editor$type3 === void 0 ? 'string' : _editor$type3,
      _editor$options2 = editor.options,
      options = _editor$options2 === void 0 ? [] : _editor$options2,
      format = editor.format;

  switch (type) {
    case 'number':
      return React.createElement(InputNumber, null);

    case 'select':
      return React.createElement(Select, {
        style: {
          width: '100%'
        }
      }, options.map(function (o) {
        return React.createElement(Select.Option, {
          key: o.key,
          value: o.key
        }, o.value);
      }));

    case 'datetime':
      return React.createElement(DatePicker, {
        showTime: true,
        format: format ? format : dateTimeFormat
      });

    case 'date':
      return React.createElement(DatePicker, {
        format: format ? format : dateFormat
      });

    case 'time':
      return React.createElement(TimePicker, {
        format: format ? format : timeFormat
      });

    case 'checkbox':
      return React.createElement(Checkbox, null);

    case 'string':
      return React.createElement(Input, null);

    default:
      return React.createElement(Input, null);
  }
};

var defaultArr = [];

var EditableTable = function EditableTable(_ref5) {
  var name = _ref5.name,
      _ref5$bordered = _ref5.bordered,
      bordered = _ref5$bordered === void 0 ? false : _ref5$bordered,
      _ref5$lang = _ref5.lang,
      lang = _ref5$lang === void 0 ? 'zh' : _ref5$lang,
      _ref5$rowKey = _ref5.rowKey,
      rowKey = _ref5$rowKey === void 0 ? 'id' : _ref5$rowKey,
      _ref5$title = _ref5.title,
      title = _ref5$title === void 0 ? '' : _ref5$title,
      _ref5$style = _ref5.style,
      style = _ref5$style === void 0 ? {} : _ref5$style,
      _ref5$newRowKeyPrefix = _ref5.newRowKeyPrefix,
      newRowKeyPrefix = _ref5$newRowKeyPrefix === void 0 ? 'new_' : _ref5$newRowKeyPrefix,
      _ref5$cols = _ref5.cols,
      cols = _ref5$cols === void 0 ? defaultArr : _ref5$cols,
      _ref5$allCols = _ref5.allCols,
      allCols = _ref5$allCols === void 0 ? [] : _ref5$allCols,
      _ref5$data = _ref5.data,
      data = _ref5$data === void 0 ? [] : _ref5$data,
      _ref5$changedData = _ref5.changedData,
      changedData = _ref5$changedData === void 0 ? defaultArr : _ref5$changedData,
      _ref5$loading = _ref5.loading,
      loading = _ref5$loading === void 0 ? false : _ref5$loading,
      _ref5$currentPage = _ref5.currentPage,
      currentPage = _ref5$currentPage === void 0 ? 1 : _ref5$currentPage,
      _ref5$pageSize = _ref5.pageSize,
      pageSize = _ref5$pageSize === void 0 ? 10 : _ref5$pageSize,
      _ref5$total = _ref5.total,
      total = _ref5$total === void 0 ? 0 : _ref5$total,
      _ref5$scroll = _ref5.scroll,
      scroll = _ref5$scroll === void 0 ? {
    x: null
  } : _ref5$scroll,
      _ref5$multiSelect = _ref5.multiSelect,
      multiSelect = _ref5$multiSelect === void 0 ? true : _ref5$multiSelect,
      _ref5$showHeader = _ref5.showHeader,
      showHeader = _ref5$showHeader === void 0 ? true : _ref5$showHeader,
      _ref5$showFooter = _ref5.showFooter,
      showFooter = _ref5$showFooter === void 0 ? true : _ref5$showFooter,
      _ref5$showToolbar = _ref5.showToolbar,
      showToolbar = _ref5$showToolbar === void 0 ? true : _ref5$showToolbar,
      _ref5$showAddBtn = _ref5.showAddBtn,
      showAddBtn = _ref5$showAddBtn === void 0 ? true : _ref5$showAddBtn,
      _ref5$showOpBtn = _ref5.showOpBtn,
      showOpBtn = _ref5$showOpBtn === void 0 ? true : _ref5$showOpBtn,
      _ref5$showSelectRecor = _ref5.showSelectRecord,
      showSelectRecord = _ref5$showSelectRecor === void 0 ? true : _ref5$showSelectRecor,
      _ref5$showSelector = _ref5.showSelector,
      defaultShowSelecor = _ref5$showSelector === void 0 ? false : _ref5$showSelector,
      _ref5$showTopPager = _ref5.showTopPager,
      showTopPager = _ref5$showTopPager === void 0 ? true : _ref5$showTopPager,
      _ref5$showBottomPager = _ref5.showBottomPager,
      showBottomPager = _ref5$showBottomPager === void 0 ? false : _ref5$showBottomPager,
      buttons = _ref5.buttons,
      _ref5$canEdit = _ref5.canEdit,
      canEdit = _ref5$canEdit === void 0 ? function () {
    return true;
  } : _ref5$canEdit,
      _ref5$canRemove = _ref5.canRemove,
      canRemove = _ref5$canRemove === void 0 ? function () {
    return true;
  } : _ref5$canRemove,
      _ref5$beforeEdit = _ref5.beforeEdit,
      beforeEdit = _ref5$beforeEdit === void 0 ? function () {
    return {};
  } : _ref5$beforeEdit,
      _ref5$afterEdit = _ref5.afterEdit,
      afterEdit = _ref5$afterEdit === void 0 ? function () {
    return {};
  } : _ref5$afterEdit,
      _ref5$onAdd = _ref5.onAdd,
      onAdd = _ref5$onAdd === void 0 ? function () {
    return {};
  } : _ref5$onAdd,
      _ref5$onFetch = _ref5.onFetch,
      onFetch = _ref5$onFetch === void 0 ? function () {} : _ref5$onFetch,
      _ref5$onChangedDataUp = _ref5.onChangedDataUpdate,
      onChangedDataUpdate = _ref5$onChangedDataUp === void 0 ? function () {} : _ref5$onChangedDataUp,
      onDownload = _ref5.onDownload,
      _ref5$onSelectRow = _ref5.onSelectRow,
      onSelectRow = _ref5$onSelectRow === void 0 ? function () {} : _ref5$onSelectRow,
      expandedRowRender = _ref5.expandedRowRender,
      _ref5$expandedFirstRo = _ref5.expandedFirstRow,
      expandedFirstRow = _ref5$expandedFirstRo === void 0 ? false : _ref5$expandedFirstRo,
      _ref5$editOnSelected = _ref5.editOnSelected,
      editOnSelected = _ref5$editOnSelected === void 0 ? false : _ref5$editOnSelected,
      _ref5$onExpandedRow = _ref5.onExpandedRow,
      onExpandedRow = _ref5$onExpandedRow === void 0 ? function () {} : _ref5$onExpandedRow,
      parentForm = _ref5.parentForm,
      rest = _objectWithoutProperties(_ref5, ["name", "bordered", "lang", "rowKey", "title", "style", "newRowKeyPrefix", "cols", "allCols", "data", "changedData", "loading", "currentPage", "pageSize", "total", "scroll", "multiSelect", "showHeader", "showFooter", "showToolbar", "showAddBtn", "showOpBtn", "showSelectRecord", "showSelector", "showTopPager", "showBottomPager", "buttons", "canEdit", "canRemove", "beforeEdit", "afterEdit", "onAdd", "onFetch", "onChangedDataUpdate", "onDownload", "onSelectRow", "expandedRowRender", "expandedFirstRow", "editOnSelected", "onExpandedRow", "parentForm"]);

  var _Form$useForm = Form.useForm(parentForm),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      form = _Form$useForm2[0];

  var _useState = useState(defaultShowSelecor),
      _useState2 = _slicedToArray(_useState, 2),
      showSelector = _useState2[0],
      setShowSelector = _useState2[1];

  var _useState3 = useState(''),
      _useState4 = _slicedToArray(_useState3, 2),
      editingKey = _useState4[0],
      setEditingKey = _useState4[1];

  var _useState5 = useState(false),
      _useState6 = _slicedToArray(_useState5, 2),
      filterVisible = _useState6[0],
      setFilterVisible = _useState6[1];

  var _useState7 = useState({}),
      _useState8 = _slicedToArray(_useState7, 2),
      filter = _useState8[0],
      setFilter = _useState8[1];

  var _useState9 = useState({}),
      _useState10 = _slicedToArray(_useState9, 2),
      sorter = _useState10[0],
      setSorter = _useState10[1];

  var _useState11 = useState({
    currentPage: currentPage,
    pageSize: pageSize
  }),
      _useState12 = _slicedToArray(_useState11, 2),
      pager = _useState12[0],
      setPager = _useState12[1];

  var _useState13 = useState([]),
      _useState14 = _slicedToArray(_useState13, 2),
      selectedRowKeys = _useState14[0],
      setSelectedRowKeys = _useState14[1];

  var _useState15 = useState(cols.map(function (c, idx) {
    return _objectSpread2({}, c, {
      idx: idx,
      visible: true
    });
  })),
      _useState16 = _slicedToArray(_useState15, 2),
      columnSeq = _useState16[0],
      setColumnSeq = _useState16[1];

  var _useState17 = useState([]),
      _useState18 = _slicedToArray(_useState17, 2),
      allColumnSeq = _useState18[0],
      setAllColumnSeq = _useState18[1];

  var _useState19 = useState(allCols),
      _useState20 = _slicedToArray(_useState19, 2),
      columns = _useState20[0],
      setColumns = _useState20[1];

  var _useState21 = useState(false),
      _useState22 = _slicedToArray(_useState21, 2),
      columnsPopVisible = _useState22[0],
      setColumnsPopVisible = _useState22[1];

  var _useState23 = useState(false),
      _useState24 = _slicedToArray(_useState23, 2),
      collapsed = _useState24[0],
      setCollapsed = _useState24[1];

  var _useState25 = useState([]),
      _useState26 = _slicedToArray(_useState25, 2),
      expandedRowKeys = _useState26[0],
      setExpandedRowKeys = _useState26[1];

  var i18n = locale[lang.toLowerCase()];
  var updateData = data.filter(function (d) {
    return !!d;
  }).map(function (d) {
    var updater = changedData.find(function (s) {
      return d[rowKey] === s[rowKey];
    });

    if (updater) {
      return _.merge({}, d, updater);
    }

    return d;
  });
  var newData = changedData.filter(function (s) {
    return s.isNew;
  });
  var temp = [];
  var dataSource = temp.concat(newData).reverse().concat(updateData);

  var handleTableChange = function handleTableChange(p, f, s) {
    var current = pager.currentPage;
    var size = pager.pageSize;
    var filters = filter;
    var sorters = sorter;

    if (p && p.currentPage) {
      current = p.currentPage;
      size = p.pageSize || pager.pageSize;
      setPager({
        currentPage: current,
        pageSize: size
      });
    }

    if (!_.isEmpty(f)) {
      if (f.clear) {
        setFilter({});
        filters = {};
      } else {
        filters = _objectSpread2({}, filter, {}, f);
        setFilter(f);
      }
    }

    if (!_.isEmpty(s)) {
      sorters = _defineProperty({}, s.field, s.order);
      setSorter(sorters);
    }

    filters = _.pickBy(filters, function (value) {
      return !_.isUndefined(value) && value !== '';
    });
    sorters = _.pickBy(sorters, function (value) {
      return !_.isUndefined(value) && value !== '';
    });
    onFetch({
      currentPage: current,
      pageSize: size
    }, filters, sorters);
  };

  var rowSelection = useMemo(function () {
    return {
      selectedRowKeys: selectedRowKeys,
      type: multiSelect ? 'checkbox' : 'radio',
      onChange: function onChange(keys, _rows) {
        return setSelectedRowKeys(keys);
      },
      onSelect: function onSelect(record, _selected, rows, _e) {
        handleSelect(record, rows);
      },
      onSelectAll: function onSelectAll(_selected, rows, _changeRows) {
        return onSelectRow(rows);
      }
    };
  }, [selectedRowKeys, multiSelect]);

  if (!showSelector) {
    rowSelection = undefined;
  }

  var handleSelect = function handleSelect(record, rows) {
    if (editOnSelected) setEditingKey(record[rowKey]);

    if (!selectedRowKeys.find(function (k) {
      return k === record[rowKey];
    })) {
      if (selectedRowKeys.length > 0) {
        var previousRow = dataSource.find(function (d) {
          return d[rowKey] === selectedRowKeys[0];
        });
        form.resetFields(_.keys(previousRow));
      }

      setSelectedRowKeys([record[rowKey]]);
      setFormValue(form, record, columns);

      if (expandedRowKeys.length > 0) {
        setExpandedRowKeys([record[rowKey]]);
      }
    }

    onSelectRow(rows);
  };

  var handleSelectRow = function handleSelectRow(record) {
    return {
      onClick: function onClick(_event) {
        if (!showSelector && (editingKey === "" || editOnSelected)) {
          handleSelect(record, [record]);
        }
      }
    };
  };

  var handleAdd = function handleAdd() {
    if (editingKey === "" || editOnSelected) {
      var newObj = onAdd();

      var key = _.uniqueId(newRowKeyPrefix);

      if (newObj) {
        newObj.isNew = true;
        if (newObj[rowKey]) key = newObj[rowKey];else newObj[rowKey] = key;
      } else {
        var _newObj;

        newObj = (_newObj = {}, _defineProperty(_newObj, rowKey, key), _defineProperty(_newObj, "isNew", true), _newObj);
      }

      setEditingKey(key);

      if (dataSource.length > 0) {
        if (selectedRowKeys.length > 0) {
          var previousRow = dataSource.find(function (d) {
            return d[rowKey] === selectedRowKeys[0];
          });
          form.resetFields(_.keys(previousRow));
        } else {
          form.resetFields(_.keys(dataSource[0]));
        }
      }

      setFormValue(form, newObj, columns);
      setExpandedRowKeys([newObj[rowKey]]);
      setSelectedRowKeys([newObj[rowKey]]);
      onSelectRow([newObj]);
      var result = updateChangedData(changedData, newObj, rowKey);
      onChangedDataUpdate(result);
    }
  };

  var handleRemove = function handleRemove(item, isDelete) {
    var result = updateChangedData(changedData, _objectSpread2({}, item, {
      isDelete: isDelete
    }), rowKey);
    onChangedDataUpdate(result);
    if (item.isNew && item[rowKey] === editingKey) setEditingKey('');
    onSelectRow([_objectSpread2({}, item, {
      isDelete: isDelete
    })]);
  };

  var handleUpdate = function handleUpdate(record, row) {
    var updateRow = _.pickBy(row, function (value) {
      return !_.isUndefined(value);
    });

    for (var key in updateRow) {
      if (moment.isMoment(updateRow[key])) {
        updateRow[key] = updateRow[key].format(updateRow[key]._f);
      }
    }

    updateRow = _.pickBy(updateRow, function (_value, key) {
      return !_.isEqual(updateRow[key], record[key]) && !(_.isObject(updateRow[key]) && _.isMatch(record[key], updateRow[key]));
    });
    var updateData = changedData;

    if (record.isNew && !record.isUpdate) {
      if (row[rowKey]) {
        record[rowKey] = row[rowKey];
        _.last(updateData)[rowKey] = row[rowKey];
        setSelectedRowKeys([row[rowKey]]);
        onSelectRow([record]);
      }
    }

    afterEdit(_objectSpread2(_defineProperty({}, rowKey, record[rowKey]), updateRow, {
      isUpdate: true
    }));
    var result = updateChangedData(updateData, _objectSpread2(_defineProperty({}, rowKey, record[rowKey]), updateRow, {
      isUpdate: true
    }), rowKey);
    onChangedDataUpdate(result);
    if (!editOnSelected) setEditingKey('');
  };

  var handleEditOk = function handleEditOk(record) {
    form.validateFields().then(function (row) {
      handleUpdate(record, row);
    }).catch(function (errorInfo) {
      if (errorInfo.outOfDate) {
        handleEditOk(record);
      }

      return errorInfo;
    });
  };

  var handleDownload = function handleDownload() {
    var allData = data;

    if (onDownload) {
      allData = onDownload(filter, sorter);
    }

    exportCSV({
      name: 'table',
      header: flatCols(columnSeq),
      data: allData
    });
  };

  var handleFormChange = function handleFormChange(values) {
    if (editOnSelected || editingKey === "" && expandedRowKeys.length > 0) {
      handleUpdate(dataSource.find(function (d) {
        return d[rowKey] === selectedRowKeys[0];
      }), values);
    }
  };

  var handleFilterClear = function handleFilterClear() {
    if (!_.isEmpty(filter)) {
      if (dataSource.length > 0) {
        form.resetFields(_.keys(dataSource[0]));
      }

      handleTableChange({
        currentPage: 1
      }, {
        clear: true
      });
    }
  };

  var getColumns = function getColumns() {
    var cols1 = columnSeq.map(function (c) {
      if (c.visible) {
        return c;
      }
    }).filter(function (c) {
      return c !== undefined;
    });

    if (showOpBtn) {
      cols1 = cols1.concat({
        title: i18n['op'],
        align: 'center',
        fixed: scroll && scroll.x ? 'right' : null,
        width: editOnSelected ? 60 : 100,
        render: function render(_text, record) {
          var editing = record[rowKey] === editingKey;
          return React.createElement(React.Fragment, null, canEdit(record) && !editOnSelected && (editing ? React.createElement(React.Fragment, null, React.createElement(Tooltip, {
            title: i18n['ok']
          }, React.createElement(CheckOutlined, {
            onClick: function onClick(e) {
              handleEditOk(record);
              e.stopPropagation();
            },
            style: {
              marginRight: 8
            }
          })), (!record.isNew || record.isUpdate) && React.createElement(Tooltip, {
            title: i18n['cancel']
          }, React.createElement(CloseOutlined, {
            onClick: function onClick(e) {
              setEditingKey('');
              e.stopPropagation();
            }
          }))) : !editOnSelected && React.createElement("a", {
            onClick: function onClick(e) {
              if (editingKey === '') {
                beforeEdit(record);
                var previousRow = dataSource.find(function (d) {
                  return d[rowKey] === selectedRowKeys[0];
                });
                form.resetFields(_.keys(previousRow));
                setFormValue(form, record, columns);
                setSelectedRowKeys([record[rowKey]]);
                setEditingKey(record[rowKey]);
                setExpandedRowKeys([record[rowKey]]);
              }

              e.stopPropagation();
            }
          }, React.createElement(Tooltip, {
            title: i18n['edit']
          }, React.createElement(EditOutlined, {
            style: editingKey === '' ? {
              color: '#666'
            } : {
              color: '#f2f2f2'
            }
          })))), canEdit(record) && canRemove(record) && record[rowKey] && !editOnSelected && React.createElement(Divider, {
            type: "vertical"
          }), canRemove(record) && (record[rowKey] || !canEdit(record)) && React.createElement(Tooltip, {
            title: record.isDelete ? i18n['undelete'] : i18n['delete']
          }, React.createElement(React.Fragment, null, !record.isDelete && React.createElement(DeleteOutlined, {
            style: {
              cursor: 'pointer'
            },
            onClick: function onClick(e) {
              handleRemove(record, true);
              e.stopPropagation();
            }
          }), record.isDelete && React.createElement(DeleteFilled, {
            style: {
              cursor: 'pointer'
            },
            onClick: function onClick(e) {
              handleRemove(record, false);
              e.stopPropagation();
            }
          }))));
        }
      });
    }

    return cols1.map(function (col, idx) {
      return initChildCols(col, idx, editingKey, rowKey);
    });
  };

  useEffect(function () {
    setColumnSeq(cols.map(function (c, idx) {
      return _objectSpread2({}, c, {
        idx: idx,
        visible: true
      });
    }));

    if (!allCols || allCols.length === 0) {
      setAllColumnSeq(cols);
    } else {
      setAllColumnSeq(allCols);
    }
  }, [cols]);
  useEffect(function () {
    setColumns(getColumns());
  }, [editingKey, changedData, columnSeq]);
  useEffect(function () {
    if (selectedRowKeys.length === 1) {
      var updatedRow = changedData.find(function (c) {
        return c[rowKey] === selectedRowKeys[0];
      });

      if (updatedRow) {
        setFormValue(form, updatedRow, columns);
      }
    }
  }, [changedData]);
  useEffect(function () {
    return setPager({
      currentPage: currentPage,
      pageSize: pageSize
    });
  }, [currentPage, pageSize]);
  useEffect(function () {
    if (expandedRowKeys.length > 0 && data && data.length > 0) {
      var _updateData = data.find(function (d) {
        return d[rowKey] === expandedRowKeys[0];
      });

      setFormValue(form, _updateData, columns);
    } else if (expandedFirstRow && data && data.length > 0) {
      setExpandedRowKeys([data[0][rowKey]]);
      setFormValue(form, data[0], columns);
      setSelectedRowKeys([data[0][rowKey]]);
      onSelectRow([data[0]]);
      if (editOnSelected) setEditingKey(data[0][rowKey]);
    }
  }, [data]);
  var expandable = useMemo(function () {
    if (expandedRowRender) {
      return {
        rowExpandable: function rowExpandable() {
          return editingKey === '' || expandedRowKeys.find(function (k) {
            return k === editingKey;
          });
        },
        expandedRowRender: expandedRowRender,
        expandedRowKeys: expandedRowKeys,
        expandIcon: function expandIcon(_ref6) {
          var expanded = _ref6.expanded,
              onExpand = _ref6.onExpand,
              record = _ref6.record;
          return expanded ? React.createElement(DownOutlined, {
            style: {
              color: '#006d75'
            },
            onClick: function onClick(e) {
              return onExpand(record, e);
            }
          }) : React.createElement(RightOutlined, {
            style: {
              color: '#006d75'
            },
            onClick: function onClick(e) {
              return onExpand(record, e);
            }
          });
        },
        onExpand: function onExpand(expanded, record) {
          if (!editOnSelected && editingKey !== '' && record[rowKey] !== editingKey) return;

          if (expanded) {
            setExpandedRowKeys([record[rowKey]]);
            onExpandedRow(record, true);
          } else {
            setExpandedRowKeys([]);
            onExpandedRow(record, false);
          }
        }
      };
    } else {
      return null;
    }
  }, [expandedRowRender, expandedRowKeys]);

  var footer = function footer() {
    return React.createElement(Row, null, React.createElement(Col, {
      span: showSelectRecord ? 2 : 0,
      style: {
        textAlign: 'left',
        whiteSpace: 'nowrap'
      }
    }, showSelectRecord && React.createElement(Checkbox, {
      onClick: function onClick(e) {
        return setShowSelector(e.target.checked);
      }
    }, i18n['select'])), React.createElement(Col, {
      span: showSelectRecord ? 22 : 24
    }, !buttons && !showBottomPager && !showAddBtn ? null : React.createElement("div", {
      className: styles.antETableBottomBar
    }, !showBottomPager && React.createElement("div", null), React.createElement("div", null, showAddBtn && React.createElement(Button, {
      icon: React.createElement(PlusOutlined, null),
      size: "small",
      onClick: handleAdd,
      style: {
        marginRight: 8
      }
    }, i18n['add']), buttons), showBottomPager && React.createElement(Pagination, {
      showSizeChanger: true,
      showQuickJumper: true,
      size: "small",
      pageSizeOptions: ['5', '10', '20', '30', '40'],
      showTotal: function showTotal(t, _range) {
        return "".concat(i18n['total.prefix'], " ").concat(t, " ").concat(i18n['total.suffix']);
      },
      onChange: function onChange(current, size) {
        return handleTableChange({
          currentPage: current,
          pageSize: size
        });
      },
      onShowSizeChange: function onShowSizeChange(current, size) {
        return handleTableChange({
          currentPage: current,
          pageSize: size
        });
      },
      current: pager.currentPage,
      pageSize: pager.pageSize,
      total: total
    }))));
  };

  var components = {
    header: {
      wrapper: EditableHWrapper,
      cell: ResizeableCell
    },
    body: {
      row: EditableRow,
      cell: EditableCell
    }
  };
  var columnsFilter = React.createElement(List, {
    bordered: true,
    size: "small",
    dataSource: allColumnSeq,
    renderItem: function renderItem(item, idx) {
      return React.createElement(List.Item, null, React.createElement(Checkbox, {
        checked: !!columnSeq.find(function (c) {
          return c.dataIndex === item.dataIndex && c.visible;
        }),
        onChange: function onChange(e) {
          if (e.target.checked) {
            var flag = true;
            setColumnSeq(columnSeq.map(function (c) {
              if (c.dataIndex === item.dataIndex) {
                flag = false;
                c.visible = true;
              }

              return c;
            }));

            if (flag) {
              // Make sure to insert it in the current position
              var insertIdx = 0;
              var tempCols = columnSeq.map(function (c) {
                if (c.idx < idx) {
                  insertIdx = c.idx;
                } else {
                  c.idx++;
                }

                return c;
              });
              setColumnSeq([].concat(_toConsumableArray(tempCols.slice(0, insertIdx + 1)), [_objectSpread2({}, item, {
                idx: idx,
                visible: true
              })], _toConsumableArray(tempCols.slice(insertIdx + 1))));
            }
          } else {
            setColumnSeq(columnSeq.map(function (c) {
              if (c.dataIndex === item.dataIndex) {
                c.visible = false;
              }

              return c;
            }));
          }
        }
      }, item.title));
    }
  });
  var table = React.createElement(Table, _extends({
    tableLayout: "fixed",
    locale: {
      emptyText: React.createElement(Empty, {
        description: i18n['empty']
      })
    },
    bordered: bordered,
    size: "middle",
    rowKey: rowKey,
    rowSelection: rowSelection,
    footer: showFooter ? footer : undefined,
    pagination: false,
    loading: loading,
    components: components,
    columns: columns,
    dataSource: dataSource,
    onChange: function onChange(p, f, s) {
      return handleTableChange(p, f, s);
    },
    onRow: handleSelectRow,
    scroll: scroll,
    expandable: expandable
  }, rest));
  return React.createElement(EditableContext.Provider, {
    value: {
      rowKey: rowKey,
      changedData: changedData,
      filter: filter,
      filterVisible: filterVisible,
      setFilter: setFilter,
      selectedRowKeys: selectedRowKeys,
      showSelector: showSelector,
      columns: columns,
      setColumns: setColumns,
      handleTableChange: handleTableChange,
      expandedRowRender: expandedRowRender
    }
  }, React.createElement("div", {
    className: styles.antETable,
    style: style
  }, showHeader && React.createElement("div", {
    className: styles.antETableHeader
  }, React.createElement("div", {
    className: styles.antETableTitleContainer
  }, React.createElement("div", {
    className: styles.antETableTitle
  }, title), title && React.createElement(Divider, {
    type: "vertical",
    style: {
      marginTop: 7
    }
  }), React.createElement("div", {
    className: styles.antETableToolbar
  }, showToolbar && React.createElement(React.Fragment, null, React.createElement(Tooltip, {
    title: filterVisible ? i18n['filter.collapse'] : i18n['filter.expand']
  }, React.createElement(React.Fragment, null, filterVisible && React.createElement(FilterFilled, {
    onClick: function onClick() {
      return setFilterVisible(!filterVisible);
    }
  }), !filterVisible && React.createElement(FilterOutlined, {
    onClick: function onClick() {
      return setFilterVisible(!filterVisible);
    }
  }))), React.createElement(Tooltip, {
    title: i18n['filter.clear']
  }, React.createElement(RestFilled, {
    style: {
      cursor: _.isEmpty(filter) ? 'default' : 'pointer',
      color: _.isEmpty(filter) ? '#ddd' : '#666'
    },
    onClick: handleFilterClear
  })), React.createElement(Tooltip, {
    title: i18n['search']
  }, React.createElement(SearchOutlined, {
    onClick: function onClick() {
      return handleTableChange({
        currentPage: 1
      });
    }
  })), React.createElement(Tooltip, {
    title: i18n['columns']
  }, React.createElement(Popover, {
    placement: "bottom",
    content: columnsFilter,
    trigger: "click",
    visible: columnsPopVisible,
    onVisibleChange: function onVisibleChange(visible) {
      return setColumnsPopVisible(visible);
    }
  }, React.createElement(UnorderedListOutlined, null)))), showTopPager && React.createElement(React.Fragment, null, showToolbar && React.createElement(Divider, {
    type: "vertical",
    style: {
      marginTop: 7
    }
  }), React.createElement(Pagination, {
    simple: true,
    defaultCurrent: 1,
    total: total,
    current: pager.currentPage,
    pageSize: pager.pageSize,
    onChange: function onChange(current, size) {
      return handleTableChange({
        currentPage: current,
        pageSize: size
      });
    },
    style: {
      display: 'inline-block',
      marginRight: 4
    }
  }), React.createElement("div", null, "".concat(i18n['total.prefix'], " ").concat(total, " ").concat(i18n['total.suffix']))))), React.createElement("div", {
    className: styles.antETableToolbarRight
  }, React.createElement(Tooltip, {
    title: i18n['download']
  }, React.createElement(DownloadOutlined, {
    onClick: function onClick() {
      return handleDownload();
    }
  })), React.createElement(Tooltip, {
    title: i18n[collapsed ? 'expand' : 'collapse']
  }, React.createElement(React.Fragment, null, collapsed && React.createElement(ColumnHeightOutlined, {
    onClick: function onClick() {
      return setCollapsed(!collapsed);
    }
  }), !collapsed && React.createElement(VerticalAlignMiddleOutlined, {
    onClick: function onClick() {
      return setCollapsed(!collapsed);
    }
  }))))), !collapsed && (parentForm ? React.createElement(React.Fragment, null, table) : React.createElement(Form, {
    name: name,
    form: form,
    onValuesChange: handleFormChange,
    initialValues: {}
  }, table))));
};

var ETableHOC = function ETableHOC(ETableComponent) {
  return (
    /*#__PURE__*/
    function (_Component) {
      _inherits(_class, _Component);

      function _class(props) {
        var _this;

        _classCallCheck(this, _class);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(_class).call(this, props));
        _this.state = {
          currentPage: 1
        };

        _this.resetTable = function () {
          _this.setState({
            currentPage: 0
          });

          _this.setState({
            currentPage: 1
          });
        };

        return _this;
      }

      _createClass(_class, [{
        key: "render",
        value: function render() {
          return React.createElement(ETableComponent, _extends({}, this.props, {
            currentPage: this.state.currentPage
          }));
        }
      }]);

      return _class;
    }(Component)
  );
};

var index = ETableHOC(EditableTable);

export default index;
